#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "n2DLib.h"
#include "graphics.h"

unsigned game_state;
short time_game, frames;
short x_cloud[3];

unsigned char end_state = 0;
unsigned short end_time = 0;

struct pl
{
	short x;
	short y;
	short win_x;
	short old_x;
	short old_y;
	short piece_x[2];
	short piece_y[2];
	int speed;
	int state;
	int gameover_time;
} player;

struct enn
{
	int x;
	int y;
	int time;
	int state;
	int time_total;
	int y_remember[3];
	int speed;
	int speed_time;
	int default_time;
	int default_speed;
	int behaviour;
} shark[3];

void Plane(void);
void Shark(void);
void start_over(void);
short rand_a_b(short a, short b);
void show_timer(void);
void end_screens(void);
void draw_game_background(void);

int main ( int argc, char* argv[] )
{
	unsigned short i;
	unsigned char done = 0;
    initBuffering();
    
    srand(time(NULL));
    
    start_over();
    
    game_state = 0;
      
	for (i=0; i < 3; i++)
	{
		x_cloud[i] = rand_a_b(0,320);
	}
      
    while (!done)
    {
		switch(game_state)
		{
			case 0:
				draw_game_background();
				drawSprite_NoCheck(title_img, 0, 0);
				if (isKeyPressed(KEY_NSPIRE_ENTER)) 
				{ 
					start_over();
					game_state = 1;
				}
			break;
			case 1:
				draw_game_background();
				Shark();
				Plane();
				if (time_game < 1)
				{
					player.win_x = player.x;
					game_state = 2;
				}
				
			break;
			case 2:
				draw_game_background();
				drawSprite(plane_img, player.win_x, player.y);
				drawSprite_NoCheck(win_img, 0, 0);
				player.win_x--;
				if (player.win_x < -128 || isKeyPressed(KEY_NSPIRE_CTRL) || isKeyPressed(KEY_NSPIRE_ENTER))
				{
					game_state = 3;
				}
			break;
			case 3:
				end_screens();
			break;
		}
			

		
 		if (isKeyPressed(KEY_NSPIRE_ESC)) done = 1;

		updateScreen();
    } // end main loop

    deinitBuffering();
    return 0;
}

void draw_game_background(void)
{
	unsigned char i;
	for (i=0; i < 3; i++)
	{
		x_cloud[i] = x_cloud[i] - 4;
		if (x_cloud[i] < -128) x_cloud[i] = 320;
	}

	drawSprite_NoCheck(yourimage_img, 0, 0);
	drawSprite(cloud_img, x_cloud[0], 48);
	drawSprite(cloud_img, x_cloud[1], 128);
	drawSprite(cloud_img, x_cloud[2], 192);		
}

void end_screens(void)
{
	switch(end_state)
	{
		case 0:
			drawSprite(end_img, 0, 0);
			end_time++;
			if (end_time > 280)
			{
				end_time = 0;
				end_state = 1;
			}
		break;
		
		case 1:
			drawSprite(end2_img, 0, 0);
			if (end_time < 360) end_time++;

			if ((isKeyPressed(KEY_NSPIRE_CTRL)) && end_time > 300)
			{
				start_over();
			}
		break;
	}

	
}

void start_over(void)
{
	unsigned char i;
	
    game_state = 0;
      
    player.x = 240;
    player.y = 128;
    player.state = 0;
    player.gameover_time = 0;
    
    for(i=0;i<2;i++)
    {
		shark[i].x = rand_a_b(0,320);
		shark[i].y = 240;
		shark[i].state = 0;
		shark[i].default_time = rand_a_b(120,250);
	}
	
	shark[0].default_speed = 3;
	shark[0].behaviour = 0;
	shark[1].behaviour = 1;
	shark[1].default_speed = 4;
	
	time_game = 666;
}

void show_timer(void)
{
	Rect score[3];
	score[0].w = 16;
	score[0].h = 16;
	score[1].w = 16;
	score[1].h = 16;
	score[2].w = 16;
	score[2].h = 16;
	
	score[0].x = 16*((time_game / 100) % 10);
	score[0].y = 0;
	score[1].x = 16*((time_game / 10) % 10);
	score[1].y = 0;
	score[2].x = 16*((time_game) % 10);
	score[2].y = 0;
	
	drawSpritePart(score_img, 0, 0, &score[0]);
	drawSpritePart(score_img, 16, 0, &score[1]);
	drawSpritePart(score_img, 32, 0, &score[2]);
	frames++;
	if (frames > 59)
	{
		frames = 0;
		time_game--;
	}
}

void Move_Plane(int move)
{
	switch(move)
	{
		case 0:
			player.y = player.y - 2;
		break;
		case 1:
			player.y = player.y + 2;
		break;
		case 2:
			player.x = player.x - 2;
		break;
		case 3:
			player.x = player.x + 2;
		break;
	}
}

void Plane(void)
{
	unsigned char i;
	
	switch(player.state)
	{
		case 0:
			drawSprite(plane_img, player.x, player.y);
			
			if (isKeyPressed(KEY_NSPIRE_UP) && player.y > 0) 
			{
				Move_Plane(0);
			}
			else if (isKeyPressed(KEY_NSPIRE_DOWN) && player.y < 212)
			{
				Move_Plane(1);
			}
			else if (isKeyPressed(KEY_NSPIRE_LEFT) && player.x > 0) 
			{
				Move_Plane(2);
			}
			else if (isKeyPressed(KEY_NSPIRE_RIGHT) && player.x < 292)
			{
				Move_Plane(3);
			}
			else if (isKeyPressed(KEY_NSPIRE_LEFTUP) && player.y > 0 && player.x > 0)
			{
				Move_Plane(2);
				Move_Plane(0);
			}
			else if (isKeyPressed(KEY_NSPIRE_DOWNLEFT) && player.y < 212 && player.x > 0)
			{
				Move_Plane(2);
				Move_Plane(1);
			}
			else if (isKeyPressed(KEY_NSPIRE_UPRIGHT) && player.y > 0 && player.x < 292)
			{
				Move_Plane(3);
				Move_Plane(0);
			}
			else if (isKeyPressed(KEY_NSPIRE_RIGHTDOWN) && player.y < 212 && player.x < 292)
			{
				Move_Plane(3);
				Move_Plane(1);
			}
			
			for(i=0;i<2;i++)
			{
				if ((player.x + 50 > shark[i].x) && (player.x < shark[i].x + 38) && (player.y + 18 > shark[i].y) && (player.y < shark[i].y + 65))
				{
					for(i=0;i<2;i++)
					{
						player.piece_x[i] =  player.x;
						player.piece_y[i] =  player.y;
					}
					player.state = 1;
				}
			}
			
			show_timer();
		break;
		case 1:
			drawSprite(plane_cut_img, player.piece_x[0], player.piece_y[0]);
			drawSprite(plane_cut2_img, player.piece_x[1], player.piece_y[1]);
			
			player.piece_x[0]=player.piece_x[0]-2;
			player.piece_x[1]=player.piece_x[1]+2;
			
			for(i=0;i<2;i++)
			{
				player.piece_y[i]=player.piece_y[i]+4;
			}
			
			if (player.piece_y[0] > 260)
			{
				player.state = 2;
			}
		break;
		case 2:
			drawSprite_NoCheck(gay_img, 96, 88);
			if (isKeyPressed(KEY_NSPIRE_CTRL)) 
			{
				start_over();
			}
		break;
	}

}


void Shark(void)
{
	unsigned short i;
	
	for (i=0;i<2;i++)
	{
		switch(shark[0].state)
		{
			case 0:
				shark[i].time_total++;
				shark[i].time++;
				
				if (shark[i].x > 264)
				{
					shark[i].x = 264;
				}
				else if (shark[i].x < 16)
				{
					shark[i].x = 16;
				}
					
				if (shark[i].time > 0)
				{
					switch(shark[i].behaviour)
					{
						case 0:
							if (shark[i].x > player.x)
							{
								shark[i].x = shark[0].x - shark[i].default_speed;
							}
							else if (shark[i].x < player.x)
							{
								shark[i].x = shark[i].x + shark[i].default_speed;
							}
						break;
						case 1:
							if (shark[i].x > player.x + 64)
							{
								shark[i].x = shark[0].x - shark[i].default_speed;
							}
							else if (shark[i].x < player.x - 64)
							{
								shark[i].x = shark[i].x + shark[i].default_speed;
							}
						break;
					}
					

						
					shark[i].time = 0;
				}
				
				if (shark[i].y > 244)
				{
					shark[i].y = shark[i].y - (shark[i].default_speed-1);
				}
				
				if (shark[i].time_total > shark[i].default_time)
				{
					shark[i].time = 0;
					shark[i].time_total = 0;
					shark[i].state = 1;
					shark[i].y_remember[0] = player.y - 24;
					
					shark[i].y_remember[1] = player.y-(player.y/2);
					shark[i].y_remember[2] = player.y-((player.y/2)*2);
				}
			break;
			case 1:
			/* Only draw the Sharks when visible on screen */
			drawSprite(shark_img, shark[0].x, shark[0].y);
			drawSprite(shark_img, shark[1].x, shark[1].y);
			
				if (shark[i].y < shark[i].y_remember[1])
				{
					shark[i].speed = 1;
				}
				else if (shark[i].y < shark[i].y_remember[2])
				{
					shark[i].speed = 2;
				}
				else
				{
					shark[i].speed = 0;
				}
				
				if (shark[i].y > shark[i].y_remember[0])
				{
					shark[i].y = shark[i].y - (shark[i].default_speed+1) - (shark[i].speed);
				}
				
				if (shark[i].y <= shark[0].y_remember[0])
				{
					shark[i].state = 2;
				}
			break;	
			case 2:
			/* Only draw the Sharks when visible on screen */
			drawSprite(shark_img, shark[0].x, shark[0].y);
			drawSprite(shark_img, shark[1].x, shark[1].y);
			
				if (shark[i].y > 192)
				{
					shark[i].speed = 2;
				}
				else if (shark[i].y > 160)
				{
					shark[i].speed = 1;
				}
				else
				{
					shark[i].speed = 0;
				}
			
				shark[i].y = shark[i].y + (shark[i].default_speed+2) + shark[i].speed;
				
				if (shark[i].y > 260)
				{
					shark[i].state = 0;
					shark[i].time = 0;
					shark[i].time_total = 0;
					shark[i].y_remember[0] = 128;
				}
			break;	
		}	
	}

	
}


// Used for random coordinate for the clouds
short rand_a_b(short a, short b)
{
    return rand()%(b-a) +a;
}
